local drawer = {
  _VERSION     = "drawer v0.1.1",
  _DESCRIPTION = "Puts draw routines in a stack queue that can be excute on love.draw()",
  _URL         = "",
  _LICENSE     = [[
    MIT LICENSE
    Copyright (c) 2018 Martin Braun
    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the
    "Software"), to deal in the Software without restriction, including
    without limitation the rights to use, copy, modify, merge, publish,
    distribute, sublicense, and/or sell copies of the Software, and to
    permit persons to whom the Software is furnished to do so, subject to
    the following conditions:
    The above copyright notice and this permission notice shall be included
    in all copies or substantial portions of the Software.
    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ]]
}

local ZMAX = 2147483647
local queue = {}
local hi = 0

function drawer.add(func, z)
	if not z then
		hi = hi + 1
		if hi >= ZMAX then hi = ZMAX - 1 end
		z = hi
	elseif z < 0 then
		z = ZMAX + z + 1
	end
	queue[z] = queue[z] or {}
	table.insert(queue[z], func)
end

function drawer.draw()
	local zkeys = {}
	for k, _ in pairs(queue) do 
		table.insert(zkeys, k) 
	end
	table.sort(zkeys)
	for _, k in ipairs(zkeys) do 
		if queue[k] then 
			for i = 1, #queue[k] do
				queue[k][i]()
			end
		end 
	end
	queue = {}
	hi = 0
end

return drawer